org.jgroups.protocols

## Class FC

- java.lang.Object
- - org.jgroups.stack.Protocol
  - - org.jgroups.protocols.FC

    public class FC
    extends Protocol

Simple flow control protocol based on a credit system. Each sender has a number of credits (bytes to send). When the credits have been exhausted, the sender blocks. Each receiver also keeps track of how many credits it has received from a sender. When credits for a sender fall below a threshold, the receiver sends more credits to the sender. Works for both unicast and multicast messages.

Note that this protocol must be located towards the top of the stack, or all down_threads from JChannel to this protocol must be set to false ! This is in order to block JChannel.send()/JChannel.down().
This is the second simplified implementation of the same model. The algorithm is sketched out in doc/FlowControl.txt
Changes (Brian) April 2006:

1. Receivers now send credits to a sender when more than min_credits have been received (rather than when min_credits are left)
2. Receivers don't send the full credits (max_credits), but rather tha actual number of bytes received

Author:
  Bela Ban

### Field Summary

### Fields inherited from class org.jgroups.stack.Protocol

`down_prot, ergonomics, id, log, name, stack, stats, up_prot`

### Constructor Summary

Constructors
Constructor and Description
`FC()`

### Method Summary

Methods
`java.lang.Object` `down(Event evt)` An event is to be sent down the stack.
`java.util.Map<java.lang.String,java.lang.Object>` `dumpStats()`
`double` `getAverageTimeBlocked()`
`long` `getMaxBlockTime()`
`java.lang.String` `getMaxBlockTimes()`
`long` `getMaxCredits()`
`long` `getMinCredits()`
`double` `getMinThreshold()`
`int` `getNumberOfBlockings()`
`int` `getNumberOfCreditRequestsReceived()`
`int` `getNumberOfCreditRequestsSent()`
`int` `getNumberOfCreditResponsesReceived()`
`int` `getNumberOfCreditResponsesSent()`
`long` `getTotalTimeBlocked()`
`void` `init()` Called after instance has been created (null constructor) and before protocol is started.
`java.lang.String` `printCreditors()`
`java.lang.String` `printCredits()`
`java.lang.String` `printReceiverCredits()`
`java.lang.String` `printSenderCredits()`
`void` `resetStats()`
`void` `setMaxBlockTime(long t)`
`void` `setMaxBlockTimes(java.lang.String str)`
`void` `setMaxCredits(long max_credits)`
`void` `setMinCredits(long min_credits)`
`void` `setMinThreshold(double min_threshold)`
`java.lang.String` `showLastBlockingTimes()`
`void` `start()` This method is called on a `Channel.connect(String)`.
`void` `stop()` This method is called on a `Channel.disconnect()`.
`void` `unblock()` Allows to unblock a blocked sender from an external program, e.g.
`java.lang.Object` `up(Event evt)` An event was received from the layer below.

### Methods inherited from class org.jgroups.stack.Protocol

`destroy, downThreadEnabled, enableStats, getConfigurableObjects, getDownProtocol, getId, getLevel, getName, getProperties, getProtocolStack, getSocketFactory, getThreadFactory, getTransport, getUpProtocol, getValue, isErgonomics, printStats, providedDownServices, providedUpServices, requiredDownServices, requiredUpServices, setDownProtocol, setErgonomics, setId, setLevel, setProperties, setPropertiesInternal, setProperty, setProtocolStack, setSocketFactory, setUpProtocol, setValue, setValues, statsEnabled, upThreadEnabled`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### FC

    public FC()

### Method Detail

#### resetStats

    public void resetStats()

Overrides:
  `resetStats` in class `Protocol`

#### getMaxCredits

    public long getMaxCredits()

#### setMaxCredits

    public void setMaxCredits(long max_credits)

#### getMinThreshold

    public double getMinThreshold()

#### setMinThreshold

    public void setMinThreshold(double min_threshold)

#### getMinCredits

    public long getMinCredits()

#### setMinCredits

    public void setMinCredits(long min_credits)

#### getNumberOfBlockings

    public int getNumberOfBlockings()

#### getMaxBlockTime

    public long getMaxBlockTime()

#### setMaxBlockTime

    public void setMaxBlockTime(long t)

#### setMaxBlockTimes

    public void setMaxBlockTimes(java.lang.String str)

#### getMaxBlockTimes

    public java.lang.String getMaxBlockTimes()

#### getTotalTimeBlocked

    public long getTotalTimeBlocked()

#### getAverageTimeBlocked

    public double getAverageTimeBlocked()

#### getNumberOfCreditRequestsReceived

    public int getNumberOfCreditRequestsReceived()

#### getNumberOfCreditRequestsSent

    public int getNumberOfCreditRequestsSent()

#### getNumberOfCreditResponsesReceived

    public int getNumberOfCreditResponsesReceived()

#### getNumberOfCreditResponsesSent

    public int getNumberOfCreditResponsesSent()

#### printSenderCredits

    public java.lang.String printSenderCredits()

#### printReceiverCredits

    public java.lang.String printReceiverCredits()

#### printCredits

    public java.lang.String printCredits()

#### printCreditors

    public java.lang.String printCreditors()

#### dumpStats

    public java.util.Map<java.lang.String,java.lang.Object> dumpStats()

Overrides:
  `dumpStats` in class `Protocol`

#### showLastBlockingTimes

    public java.lang.String showLastBlockingTimes()

#### unblock

    public void unblock()

Allows to unblock a blocked sender from an external program, e.g. JMX

#### init

    public void init()
              throws java.lang.Exception

Description copied from class: `Protocol`
Called after instance has been created (null constructor) and before protocol is started. Properties are already set. Other protocols are not yet connected and events cannot yet be sent.

Overrides:
  `init` in class `Protocol`
Throws:
  `java.lang.Exception` - Thrown if protocol cannot be initialized successfully. This will cause the ProtocolStack to fail, so the channel constructor will throw an exception

#### start

    public void start()
               throws java.lang.Exception

Description copied from class: `Protocol`
This method is called on a `Channel.connect(String)`. Starts work. Protocols are connected and queues are ready to receive events. Will be called from bottom to top. This call will replace the START and START_OK events.

Overrides:
  `start` in class `Protocol`
Throws:
  `java.lang.Exception` - Thrown if protocol cannot be started successfully. This will cause the ProtocolStack to fail, so `Channel.connect(String)` will throw an exception

#### stop

    public void stop()

Description copied from class: `Protocol`
This method is called on a `Channel.disconnect()`. Stops work (e.g. by closing multicast socket). Will be called from top to bottom. This means that at the time of the method invocation the neighbor protocol below is still working. This method will replace the STOP, STOP_OK, CLEANUP and CLEANUP_OK events. The ProtocolStack guarantees that when this method is called all messages in the down queue will have been flushed

Overrides:
  `stop` in class `Protocol`

#### down

    public java.lang.Object down(Event evt)

Description copied from class: `Protocol`
An event is to be sent down the stack. The layer may want to examine its type and perform some action on it, depending on the event's type. If the event is a message MSG, then the layer may need to add a header to it (or do nothing at all) before sending it down the stack using `down_prot.down()`. In case of a GET_ADDRESS event (which tries to retrieve the stack's address from one of the bottom layers), the layer may need to send a new response event back up the stack using `up_prot.up()`.

Overrides:
  `down` in class `Protocol`

#### up

    public java.lang.Object up(Event evt)

Description copied from class: `Protocol`
An event was received from the layer below. Usually the current layer will want to examine the event type and - depending on its type - perform some computation (e.g. removing headers from a MSG event type, or updating the internal membership list when receiving a VIEW_CHANGE event). Finally the event is either a) discarded, or b) an event is sent down the stack using `down_prot.down()` or c) the event (or another event) is sent up the stack using `up_prot.up()`.

Overrides:
  `up` in class `Protocol`